Index: hellenes/temp_special_hellenization.json
===================================================================
--- hellenes/temp_special_hellenization.json	(revision 15207)
+++ hellenes/temp_special_hellenization.json	(working copy)
@@ -9,7 +9,7 @@
 	},
 	"description": "The Hellenic culture was very influential. Greek became the spoken language of commerce and politics for much of the Mediterranean basin and Middle East for centuries.",
 	"cost": {"food": 0, "wood": 0, "stone": 0, "metal": 1000},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"any": [{"civ": "hele"},{"civ": "athen"},{"civ": "mace"},{"civ": "spart"},{"civ": "theb"}]}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "political_face.png",
 	"researchTime": 60,
Index: hellenes/attack_inf_spearfighting.json
===================================================================
--- hellenes/attack_inf_spearfighting.json	(revision 15207)
+++ hellenes/attack_inf_spearfighting.json	(working copy)
@@ -9,7 +9,7 @@
 	},
 	"description": "Spear fighting training increases damage of infantry spear units.",
 	"cost": {"food": 0, "wood": 0, "stone": 0, "metal": 100},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"any": [{"civ": "hele"},{"civ": "athen"},{"civ": "mace"},{"civ": "spart"},{"civ": "theb"}]}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "spear.png",
 	"researchTime": 40,
Index: hellenes/spartans_agoge.json
===================================================================
--- hellenes/spartans_agoge.json	(revision 15207)
+++ hellenes/spartans_agoge.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "The Agoge",
 	"description": "Spartans were housed and trained from a young age to be superlative warriors and to endure any hardship a military life can give them.",
 	"cost": {"food": 500, "wood": 0, "stone": 0, "metal": 500},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "spart"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "agoge.png",
 	"researchTime": 60,
Index: hellenes/special_long_walls.json
===================================================================
--- hellenes/special_long_walls.json	(revision 15207)
+++ hellenes/special_long_walls.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Athenian Long Walls",
 	"description": "The Long Walls of Athens were constructed under the auspices of the wily Themistocles and extended 6 km from the city to the port of Piraeus. This secured the city's sea supply routes and prevented an enemy from starving out the city during a siege.",
 	"cost": {"food": 0, "wood": 0, "stone": 250, "metal": 250},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "athen"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "crenelations.png",
 	"researchTime": 60,
Index: hellenes/special_iphicratean_reforms.json
===================================================================
--- hellenes/special_iphicratean_reforms.json	(revision 15207)
+++ hellenes/special_iphicratean_reforms.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Iphicratean Reforms",
 	"description": "Athenian triremes can train Marines (Epibates Athenaikos) and Cretan Mercenary Archers (Toxotes Kretikos).",
 	"cost": { "food": 300, "wood": 0, "stone": 0, "metal": 300 },
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "athen"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "helmet_corinthian_crest.png",
 	"researchTime": 60,
Index: mauryans/special_archery_tradition.json
===================================================================
--- mauryans/special_archery_tradition.json	(revision 15207)
+++ mauryans/special_archery_tradition.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Archery Tradition",
 	"description": "The Indians had a tradition of fine archery and a penchant for using massed archers in battle.",
 	"cost": {"food": 200, "wood": 300, "stone": 0, "metal": 150},
-	"requirements": {"tech": "phase_village"},
+	"requirements": {"all": [{"tech": "phase_village"}, {"civ": "maur"}]},
 	"requirementsTooltip": "Unlocked in Village Phase.",
 	"icon": "armor_plates_ranged.png",
 	"researchTime": 60,
Index: romans/decay_logistics.json
===================================================================
--- romans/decay_logistics.json	(revision 15207)
+++ romans/decay_logistics.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Roman Logistics",
 	"description": "The Romans were masters of the logistics of warfare.",
 	"cost": {"food": 0, "wood": 100, "stone": 100, "metal": 0},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "rome"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "handcart_empty.png",
 	"researchTime": 40,
Index: persians/immortals.json
===================================================================
--- persians/immortals.json	(revision 15207)
+++ persians/immortals.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Immortals",
 	"description": "The Anusiya champion infantry train twice as fast, but lose a little max health.",
 	"cost": {"food": 200, "wood": 0, "stone": 0, "metal": 200},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "pers"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "fist_spear.png",
 	"researchTime": 60,
Index: persians/special_archery_tradition.json
===================================================================
--- persians/special_archery_tradition.json	(revision 15207)
+++ persians/special_archery_tradition.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Archery Tradition",
 	"description": "The Persians had a tradition of fine archery and a penchant for using massed archers in battle.",
 	"cost": {"food": 200, "wood": 300, "stone": 0, "metal": 150},
-	"requirements": {"tech": "phase_village"},
+	"requirements": {"all": [{"tech": "phase_village"}, {"civ": "pers"}]},
 	"requirementsTooltip": "Unlocked in Village Phase.",
 	"icon": "armor_plates_ranged.png",
 	"researchTime": 60,
Index: persians/training_levy_cavalry.json
===================================================================
--- persians/training_levy_cavalry.json	(revision 15207)
+++ persians/training_levy_cavalry.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Levy Cavalry",
 	"description": "Calling up cavalry levies in time of war helps bolster the ranks of a king's army.",
 	"cost": {"food": 100, "wood": 0, "stone": 0, "metal": 0},
-	"requirements": {"tech": "phase_town"},
+	"requirements": {"all": [{"tech": "phase_town"}, {"civ": "pers"}]},
 	"requirementsTooltip": "Unlocked in Town Phase.",
 	"icon": "horse_trainer.png",
 	"researchTime": 40,
Index: persians/training_conscription_infantry.json
===================================================================
--- persians/training_conscription_infantry.json	(revision 15207)
+++ persians/training_conscription_infantry.json	(working copy)
@@ -3,7 +3,7 @@
     "supersedes": "persians/training_levy_infantry",
 	"description": "Significantly increase training speed of soldiers at the barracks by training them in large batches or battalions.",
 	"cost": {"food": 500, "wood": 0, "stone": 0, "metal": 0},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "pers"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "fist_spear.png",
 	"researchTime": 40,
Index: persians/persian_architecture.json
===================================================================
--- persians/persian_architecture.json	(revision 15207)
+++ persians/persian_architecture.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Persian Architecture",
 	"description": "The Persians built the wonderful 1677 mile-long Royal Highway from Sardis to Susa; Darius the Great and Xerxes also built the magnificent Persepolis; Cyrus the Great greatly improved Ecbatana and virtually 'rebuilt' the old Elamite capital of Susa.",
 	"cost": {"food": 0, "wood": 200, "stone": 200, "metal": 0},
-	"requirements": {"tech": "phase_village"},
+	"requirements": {"all": [{"tech": "phase_village"}, {"civ": "pers"}]},
 	"icon": "stone_blocks.png",
 	"researchTime": 60,
 	"tooltip": "All Persian structures +25% health, but also +20% build time.",
Index: persians/training_levy_infantry.json
===================================================================
--- persians/training_levy_infantry.json	(revision 15207)
+++ persians/training_levy_infantry.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Levy Infantry",
 	"description": "Calling up infantry levies in time of war helps bolster the ranks of a king's army.",
 	"cost": {"food": 100, "wood": 0, "stone": 0, "metal": 0},
-	"requirements": {"tech": "phase_town"},
+	"requirements": {"all": [{"tech": "phase_town"}, {"civ": "pers"}]},
 	"requirementsTooltip": "Unlocked in Town Phase.",
 	"icon": "clenched_fist.png",
 	"researchTime": 40,
Index: persians/special_equine_transports.json
===================================================================
--- persians/special_equine_transports.json	(revision 15207)
+++ persians/special_equine_transports.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Equine Transports",
 	"description": "Early Achaemenid rulers acted towards making Persia the first great Asian empire to rule the seas. The Great King behaved favourably towards the various sea peoples in order to secure their services, but also carried out various marine initiatives. During the reign of Darius the Great, for example, a canal was built in Egypt and a Persian navy was sent exploring the Indus river. According to Herodotus, some 300 ships in the Persian navy were retrofitted to carry horses and their riders.",
 	"cost": { "food": 0, "wood": 300, "stone": 0, "metal": 300 },
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "pers"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "horse_rider.png",
 	"researchTime": 60,
Index: persians/training_conscription_cavalry.json
===================================================================
--- persians/training_conscription_cavalry.json	(revision 15207)
+++ persians/training_conscription_cavalry.json	(working copy)
@@ -3,7 +3,7 @@
     "supersedes": "persians/training_levy_cavalry",
 	"description": "Significantly increase training speed of cavalry at the stables by training them in large batches or battalions.",
 	"cost": {"food": 500, "wood": 0, "stone": 0, "metal": 0},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "pers"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "horse_rider.png",
 	"researchTime": 40,
Index: successors/special_war_horses.json
===================================================================
--- successors/special_war_horses.json	(revision 15207)
+++ successors/special_war_horses.json	(working copy)
@@ -5,7 +5,7 @@
 	},
 	"description": "The now-extinct Nisian breed of horse was one of the largest and robust horses of ancient times. They were highly sought after by the Seleucids and Persians as both rider and mount gained heavier armor as time progressed.",
 	"cost": {"food": 200, "wood": 0, "stone": 0, "metal": 200},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "sele"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "nisean_war_horses.png",
 	"researchTime": 60,
Index: successors/upgrade_mace_silvershields.json
===================================================================
--- successors/upgrade_mace_silvershields.json	(revision 15207)
+++ successors/upgrade_mace_silvershields.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Silver Shields Regiment",
 	"description": "The Silver Shields, or Argyraspidai, were the elite heavy infantry arm of the Macedonian army.",
 	"cost": {"food": 0, "wood": 0, "stone": 0, "metal": 500},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "mace"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "shields_generic_silver.png",
 	"researchTime": 40,
Index: successors/unlock_reform_army.json
===================================================================
--- successors/unlock_reform_army.json	(revision 15207)
+++ successors/unlock_reform_army.json	(working copy)
@@ -3,7 +3,7 @@
 	"genericName": "Reform Army",
 	"description": "The reform army of the Seleucids.",
 	"cost": {"food": 0, "wood": 0, "stone": 0, "metal": 0},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "sele"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "helmet_corinthian_crest.png",
 	"researchTime": 0,
Index: successors/unlock_traditional_army.json
===================================================================
--- successors/unlock_traditional_army.json	(revision 15207)
+++ successors/unlock_traditional_army.json	(working copy)
@@ -3,7 +3,7 @@
 	"genericName": "Traditional Army",
 	"description": "The traditional army of the Seleucids.",
 	"cost": {"food": 0, "wood": 0, "stone": 0, "metal": 0},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "sele"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "helmet_corinthian_crest.png",
 	"researchTime": 0,
Index: successors/special_parade_of_daphne.json
===================================================================
--- successors/special_parade_of_daphne.json	(revision 15207)
+++ successors/special_parade_of_daphne.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Parade of Daphne",
 	"description": "Significantly increase training speed of champions and siege weapons at the fortress by training them in large batches or battalions.",
 	"cost": {"food": 500, "wood": 0, "stone": 0, "metal": 500},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "sele"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "parade_of_daphne.png",
 	"researchTime": 60,
Index: successors/special_hellenistic_metropolis.json
===================================================================
--- successors/special_hellenistic_metropolis.json	(revision 15207)
+++ successors/special_hellenistic_metropolis.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Hellenistic Metropolis",
 	"description": "Beginning with Alexander, the Hellenistic monarchs founded many cities throughout their empires, where Greek culture and art blended with local customs to create the motley Hellenistic civilization.",
 	"cost": {"food": 0, "wood": 0, "stone": 500, "metal": 500},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"any":[{"civ": "mace", "civ": "ptol", "civ": "sele"}]}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "statue_face_stone.png",
 	"researchTime": 60,
Index: carthaginians/traintime_italian_mercs_2.json
===================================================================
--- carthaginians/traintime_italian_mercs_2.json	(revision 15207)
+++ carthaginians/traintime_italian_mercs_2.json	(working copy)
@@ -3,7 +3,7 @@
 	"genericName": "Italiote Hegemony",
 	"description": "Italian mercenaries have their train time decreased.",
 	"cost": {"food": 0, "wood": 0, "stone": 200, "metal": 200},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "fist_spear.png",
 	"researchTime": 40,
Index: carthaginians/cost_celt_mercs.json
===================================================================
--- carthaginians/cost_celt_mercs.json	(revision 15207)
+++ carthaginians/cost_celt_mercs.json	(working copy)
@@ -3,7 +3,7 @@
 	"genericName": "Celtic Mercenary Captain",
 	"description": "Celtic mercenaries have their metal cost decreased.",
 	"cost": {"food": 100, "wood": 0, "stone": 0, "metal": 100},
-	"requirements": {"tech": "phase_town"},
+	"requirements": {"all": [{"tech": "phase_town"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in Town Phase.",
 	"icon": "helmet_corinthian_silver.png",
 	"researchTime": 40,
Index: carthaginians/cost_iberian_mercs_2.json
===================================================================
--- carthaginians/cost_iberian_mercs_2.json	(revision 15207)
+++ carthaginians/cost_iberian_mercs_2.json	(working copy)
@@ -3,7 +3,7 @@
 	"genericName": "Celtiberian Mercenary General",
 	"description": "Iberian mercenaries have their metal cost decreased.",
 	"cost": {"food": 200, "wood": 0, "stone": 0, "metal": 200},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "helmet_corinthian_crest.png",
 	"researchTime": 40,
Index: carthaginians/upgrade_rank_elite_iberian.json
===================================================================
--- carthaginians/upgrade_rank_elite_iberian.json	(revision 15207)
+++ carthaginians/upgrade_rank_elite_iberian.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Elite Iberian Mercenaries",
 	"description": "Upgrade all of your Iberian Mercenaries to Elite rank.",
 	"cost": {"food": 500, "wood": 0, "stone": 0, "metal": 500},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "upgrade_elite.png",
 	"researchTime": 40,
Index: carthaginians/traintime_celt_mercs_2.json
===================================================================
--- carthaginians/traintime_celt_mercs_2.json	(revision 15207)
+++ carthaginians/traintime_celt_mercs_2.json	(working copy)
@@ -3,7 +3,7 @@
 	"genericName": "Gallic Hegemony",
 	"description": "Celtic mercenaries have their train time decreased.",
 	"cost": {"food": 0, "wood": 0, "stone": 200, "metal": 200},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "fist_spear.png",
 	"researchTime": 40,
Index: carthaginians/upgrade_rank_elite_italiote.json
===================================================================
--- carthaginians/upgrade_rank_elite_italiote.json	(revision 15207)
+++ carthaginians/upgrade_rank_elite_italiote.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Elite Italiote Mercenaries",
 	"description": "Upgrade all of your Italiote Mercenaries to Elite rank.",
 	"cost": {"food": 500, "wood": 0, "stone": 0, "metal": 500},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "upgrade_elite.png",
 	"researchTime": 40,
Index: carthaginians/upgrade_rank_elite_celts.json
===================================================================
--- carthaginians/upgrade_rank_elite_celts.json	(revision 15207)
+++ carthaginians/upgrade_rank_elite_celts.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Elite Celtic Mercenaries",
 	"description": "Upgrade all of your Celtic Mercenaries to Elite rank.",
 	"cost": {"food": 500, "wood": 0, "stone": 0, "metal": 500},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "upgrade_elite.png",
 	"researchTime": 40,
Index: carthaginians/traintime_iberian_mercs.json
===================================================================
--- carthaginians/traintime_iberian_mercs.json	(revision 15207)
+++ carthaginians/traintime_iberian_mercs.json	(working copy)
@@ -3,7 +3,7 @@
 	"genericName": "Iberian Alliance",
 	"description": "Iberian mercenaries have their train time decreased.",
 	"cost": {"food": 0, "wood": 100, "stone": 0, "metal": 100},
-	"requirements": {"tech": "phase_town"},
+	"requirements": {"all": [{"tech": "phase_town"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in Town Phase.",
 	"icon": "clenched_fist.png",
 	"researchTime": 40,
Index: carthaginians/upgrade_rank_advanced_iberian.json
===================================================================
--- carthaginians/upgrade_rank_advanced_iberian.json	(revision 15207)
+++ carthaginians/upgrade_rank_advanced_iberian.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Advanced Iberian Mercenaries",
 	"description": "Upgrade all of your Iberian mercenaries to Advanced rank.",
 	"cost": {"food": 0, "wood": 0, "stone": 0, "metal": 300},
-	"requirements": {"tech": "phase_town"},
+	"requirements": {"all": [{"tech": "phase_town"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in Town Phase.",
 	"icon": "upgrade_advanced.png",
 	"researchTime": 40,
Index: carthaginians/upgrade_rank_advanced_italiote.json
===================================================================
--- carthaginians/upgrade_rank_advanced_italiote.json	(revision 15207)
+++ carthaginians/upgrade_rank_advanced_italiote.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Advanced Italiote Mercenaries",
 	"description": "Upgrade all of your Italiote mercenaries to Advanced rank.",
 	"cost": {"food": 0, "wood": 0, "stone": 0, "metal": 300},
-	"requirements": {"tech": "phase_town"},
+	"requirements": {"all": [{"tech": "phase_town"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in Town Phase.",
 	"icon": "upgrade_advanced.png",
 	"researchTime": 40,
Index: carthaginians/upgrade_rank_advanced_celts.json
===================================================================
--- carthaginians/upgrade_rank_advanced_celts.json	(revision 15207)
+++ carthaginians/upgrade_rank_advanced_celts.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Advanced Celtic Mercenaries",
 	"description": "Upgrade all of your Celtic mercenaries to Advanced rank.",
 	"cost": {"food": 0, "wood": 0, "stone": 0, "metal": 300},
-	"requirements": {"tech": "phase_town"},
+	"requirements": {"all": [{"tech": "phase_town"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in Town Phase.",
 	"icon": "upgrade_advanced.png",
 	"researchTime": 40,
Index: carthaginians/cost_italian_mercs_2.json
===================================================================
--- carthaginians/cost_italian_mercs_2.json	(revision 15207)
+++ carthaginians/cost_italian_mercs_2.json	(working copy)
@@ -3,7 +3,7 @@
 	"genericName": "Italiote Mercenary General",
 	"description": "Italian mercenaries have their metal cost decreased.",
 	"cost": {"food": 200, "wood": 0, "stone": 0, "metal": 200},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "helmet_corinthian_crest.png",
 	"researchTime": 40,
Index: carthaginians/traintime_italian_mercs.json
===================================================================
--- carthaginians/traintime_italian_mercs.json	(revision 15207)
+++ carthaginians/traintime_italian_mercs.json	(working copy)
@@ -3,7 +3,7 @@
 	"genericName": "Italiote Alliance",
 	"description": "Italian mercenaries have their train time decreased.",
 	"cost": {"food": 0, "wood": 100, "stone": 0, "metal": 100},
-	"requirements": {"tech": "phase_town"},
+	"requirements": {"all": [{"tech": "phase_town"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in Town Phase.",
 	"icon": "clenched_fist.png",
 	"researchTime": 40,
Index: carthaginians/cost_celt_mercs_2.json
===================================================================
--- carthaginians/cost_celt_mercs_2.json	(revision 15207)
+++ carthaginians/cost_celt_mercs_2.json	(working copy)
@@ -3,7 +3,7 @@
 	"genericName": "Gallic Mercenary General",
 	"description": "Celtic mercenaries have their metal cost decreased.",
 	"cost": {"food": 200, "wood": 0, "stone": 0, "metal": 200},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "helmet_corinthian_crest.png",
 	"researchTime": 40,
Index: carthaginians/cost_iberian_mercs.json
===================================================================
--- carthaginians/cost_iberian_mercs.json	(revision 15207)
+++ carthaginians/cost_iberian_mercs.json	(working copy)
@@ -3,7 +3,7 @@
 	"genericName": "Lusitanian Mercenary Captain",
 	"description": "Iberian mercenaries have their metal cost decreased.",
 	"cost": {"food": 100, "wood": 0, "stone": 0, "metal": 100},
-	"requirements": {"tech": "phase_town"},
+	"requirements": {"all": [{"tech": "phase_town"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in Town Phase.",
 	"icon": "helmet_corinthian_silver.png",
 	"researchTime": 40,
Index: carthaginians/traintime_celt_mercs.json
===================================================================
--- carthaginians/traintime_celt_mercs.json	(revision 15207)
+++ carthaginians/traintime_celt_mercs.json	(working copy)
@@ -3,7 +3,7 @@
 	"genericName": "Celtic Alliance",
 	"description": "Celtic mercenaries have their train time decreased.",
 	"cost": {"food": 0, "wood": 100, "stone": 0, "metal": 100},
-	"requirements": {"tech": "phase_town"},
+	"requirements": {"all": [{"tech": "phase_town"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in Town Phase.",
 	"icon": "clenched_fist.png",
 	"researchTime": 40,
Index: carthaginians/traintime_iberian_mercs_2.json
===================================================================
--- carthaginians/traintime_iberian_mercs_2.json	(revision 15207)
+++ carthaginians/traintime_iberian_mercs_2.json	(working copy)
@@ -3,7 +3,7 @@
 	"genericName": "Iberian Hegemony",
 	"description": "Iberian mercenaries have their train time decreased.",
 	"cost": {"food": 0, "wood": 0, "stone": 200, "metal": 200},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "fist_spear.png",
 	"researchTime": 40,
Index: carthaginians/special_colonisation.json
===================================================================
--- carthaginians/special_colonisation.json	(revision 15207)
+++ carthaginians/special_colonisation.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Colonization",
 	"description": "Carthaginians established many trading centers as colonies and ultimately held dominion over 300 cities and towns in North Africa alone.",
 	"cost": {"food": 0, "wood": 500, "stone": 0, "metal": 500},
-	"requirements": {"tech": "phase_town"},
+	"requirements": {"all": [{"tech": "phase_town"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in Town Phase.",
 	"icon": "political_face.png",
 	"researchTime": 60,
Index: carthaginians/training_phoenician_naval_architects.json
===================================================================
--- carthaginians/training_phoenician_naval_architects.json	(revision 15207)
+++ carthaginians/training_phoenician_naval_architects.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Phoenician Naval Architects",
 	"description": "Significantly increase build speed of batches of ships at the Shipyard.",
 	"cost": {"food": 200, "wood": 200, "stone": 0, "metal": 0},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "calipers.png",
 	"researchTime": 40,
Index: carthaginians/cost_italian_mercs.json
===================================================================
--- carthaginians/cost_italian_mercs.json	(revision 15207)
+++ carthaginians/cost_italian_mercs.json	(working copy)
@@ -3,7 +3,7 @@
 	"genericName": "Italiote Mercenary Captain",
 	"description": "Italian mercenaries have their metal cost decreased.",
 	"cost": {"food": 100, "wood": 0, "stone": 0, "metal": 100},
-	"requirements": {"tech": "phase_town"},
+	"requirements": {"all": [{"tech": "phase_town"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in Town Phase.",
 	"icon": "helmet_corinthian_silver.png",
 	"researchTime": 40,
Index: carthaginians/special_exploration.json
===================================================================
--- carthaginians/special_exploration.json	(revision 15207)
+++ carthaginians/special_exploration.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Exploration",
 	"description": "Nobody knew better than the Carthaginians where in the ancient world they were going and going to go; their merchant traders had missions to everywhere.",
 	"cost": {"food": 200, "wood": 0, "stone": 0, "metal": 200},
-	"requirements": {"tech": "phase_town"},
+	"requirements": {"all": [{"tech": "phase_town"}, {"civ": "cart"}]},
 	"requirementsTooltip": "Unlocked in Town Phase.",
 	"icon": "armor_ship_gold.png",
 	"researchTime": 60,
Index: celts/special_gather_crop_rotation.json
===================================================================
--- celts/special_gather_crop_rotation.json	(revision 15207)
+++ celts/special_gather_crop_rotation.json	(working copy)
@@ -2,7 +2,7 @@
 	"genericName": "Crop Rotation",
 	"description": "Crop rotation increases yield by preventing the depletion of vital nutrients and minerals from the soil.",
 	"cost": {"food": 300, "wood": 300, "stone": 0, "metal": 0},
-	"requirements": {"tech": "phase_city"},
+	"requirements": {"all": [{"tech": "phase_city"}, {"any": [{"civ": "celt"}, {"civ": "brit"}, {"civ": "gaul"}]}]},
 	"requirementsTooltip": "Unlocked in City Phase.",
 	"icon": "crop_rotation.png",
 	"researchTime": 40,